/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef CONFIG_GEN_H
#define CONFIG_GEN_H

class QHBoxLayout;
class QComboBox;
class QLabel;

#include "tools/misc_gui.h"
#include "tools/tool.h"
namespace DeviceChooser { class Button; };
namespace Device {
  class Memory;
  class MemoryEditor;
};
class SimpleTextEditor;

class ConfigGenerator : public Dialog
{
Q_OBJECT
public:
  ConfigGenerator(const QString &device, uint group, PURL::SourceType stype, QWidget *parent);
  virtual ~ConfigGenerator();
  void set(const QString &device, uint group, PURL::SourceType stype);

private slots:
  void typeChanged();
  void set();
  void computeConfig();
  void copyToClipboard();

private:
  Device::Memory    *_memory;
  QHBoxLayout       *_hbox;
  DeviceChooser::Button *_deviceChooser;
  QComboBox         *_configType, *_sourceType;
  Device::MemoryEditor *_configEditor;
  SimpleTextEditor  *_text;
  QLabel            *_warning;

  void setSourceType(PURL::SourceType stype);
};

#endif
