/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DEVICE_GROUP_UI_H
#define DEVICE_GROUP_UI_H

class QWidget;
class KPopupMenu;
class KListViewItem;
class KAction;

#include "devices/base/generic_device.h"
#include "common/group.h"

class HexEditor;

namespace Device
{
class Memory;
class HexView;
class RegisterView;
class MemoryEditor;
class RegisterItem;

class GroupUI : public ::GroupUI
{
public:
  GroupUI(::Group &group) : ::GroupUI(group) {}
  virtual QString informationUrl(const Device::Data &data) const = 0;
  virtual QString informationHtml(const Device::Data &data) const = 0;
  virtual HexView *createHexView(const HexEditor &editor, QWidget *parent) const = 0;
  virtual RegisterView *createRegisterView(const Device::Data &data, bool debugging, QWidget *parent) const = 0;
  virtual QString listviewGroup(const QString &device) const = 0;
  virtual MemoryEditor *createConfigEditor(Device::Memory &memory, QWidget *parent) const = 0;
  virtual KPopupMenu *createWatchPopup(const Device::Data &data, QWidget *parent) const = 0;
  virtual RegisterItem *createRegisterItem(const Device::Data &data, uint index, KListViewItem *parent) const = 0;
};

}; // namespace

#endif
