/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "register_view.h"

#include "devices/base/generic_device.h"

//-----------------------------------------------------------------------------
Device::RegisterItem::RegisterItem(const Device::Data &data, uint index, KListViewItem *parent)
  : EditListViewItem(parent), _data(data), _index(index), _value(Device::INVALID), _changed(false)
{}

void Device::RegisterItem::init()
{
  setText(0, toHexLabel(address(), nbCharsAddress()) + ":");
  setText(1, name());
  setValue(Device::INVALID);
  setSelectable(false);
}

void Device::RegisterItem::setValue(uint value)
{
  _changed = ( _value!=value );
  _value = value;
  QString text = (value==Device::INVALID ? "--" : toHexLabel(value, nbCharsValue()));
  setText(2, text);
}

void Device::RegisterItem::paintCell(QPainter *p, const QColorGroup &cg, int column, int width, int align)
{
  QColorGroup ncg = cg;
  if ( column==2 && _changed ) ncg.setColor(QColorGroup::Text, red);
  EditListViewItem::paintCell(p, ncg, column, width, align);
}

QWidget *Device::RegisterItem::editWidgetFactory(int col) const
{
  return 0;
/*
  if ( col!=0 ) return 0;
  QComboBox *combo = new QComboBox(false, 0);
  const Device::Data *data = MainWindow::self().currentDeviceData();
  if ( data==0 ) return combo;
  if (_unset) combo->insertItem(i18n("<select>"));
  uint nbRegisters = data->nbRegisters();
  for (uint i=0; i<nbRegisters; i++) {
    QString name = Watch::registerName(i);
    if ( name.isEmpty() ) continue;
    combo->insertItem(name);
  }
  combo->setCurrentText(text(0));
  return combo;
*/
}

void Device::RegisterItem::editDone(int col, const QWidget *edit)
{
/*
  if ( col==0 ) {
    const QComboBox *combo = static_cast<const QComboBox *>(edit);
    if ( _unset && combo->currentItem()==0 ) return;
    setText(0, combo->currentText());
    if (_unset) {
      static_cast<View *>(listView())->addRegister(this);
      _unset = false;
    }
  }
*/
}
