/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "mem24_group_ui.h"

#include <klocale.h>
#include <kaction.h>

#include "devices/mem24/mem24.h"
#include "mem24_hex_view.h"

QString Mem24::GroupUI::informationUrl(const Device::Data &data) const
{
  QString url = "http://microchip.com/stellent/idcplg?IdcService=SS_GET_PAGE&nodeId=";
  if ( data.document().isEmpty() )
   url += "2044&AllWords=" + data.name();
  else url += "1335&dDocName=en" + data.document();
  return url;
}

QString Mem24::GroupUI::informationHtml(const Device::Data &data) const
{
  const Data &mdata = static_cast<const Data &>(data);
  QString s = "<table>";
  QString tmp = i18n("%1 bytes").arg(KGlobal::locale()->formatNumber(mdata.nbBytes(), 0));
  s += htmlTableRow(i18n("Memory Size"), tmp);
  s += "</table>";
  return s;
}

Device::HexView *Mem24::GroupUI::createHexView(const HexEditor &editor, QWidget *parent) const
{
  return new HexView(editor, parent);
}
