/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef MEM24_GROUP_UI_H
#define MEM24_GROUP_UI_H

#include "devices/base/gui/device_group_ui.h"

namespace Mem24
{
class GroupUI : public Device::GroupUI
{
public:
  GroupUI(::Group &group) : Device::GroupUI(group) {}
  virtual QString informationUrl(const Device::Data &data) const;
  virtual QString informationHtml(const Device::Data &data) const;
  virtual Device::HexView *createHexView(const HexEditor &editor, QWidget *parent) const;
  virtual Device::RegisterView *createRegisterView(const Device::Data &, bool, QWidget *) const { return 0; }
  virtual QString listviewGroup(const QString &device) const { return device.mid(0, 2); }
  virtual Device::MemoryEditor *createConfigEditor(Device::Memory &, QWidget *) const { return 0; }
  virtual KPopupMenu *createWatchPopup(const Device::Data &, QWidget *) const { return 0; }
  virtual Device::RegisterItem *createRegisterItem(const Device::Data &, uint, KListViewItem *) const { return 0; }
};

}; // namespace

#endif
