/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef MEM24_H
#define MEM24_H

#include "common/misc.h"
#include "devices/base/generic_device.h"

namespace Mem24
{
class XmlToData;
class ConstData;
class Group;

//-----------------------------------------------------------------------------
class Data : public Device::Data
{
public:
  Data() {}
  Data(const Device::ConstData &data);
  uint nbBytes() const { return _nbBytes; }
  virtual bool matchId(uint, uint, Device::IdData &) const { return false; }
  virtual uint nbBitsAddress() const { return nbBits(_nbBytes-1); }
  virtual bool canWriteCalibration() const { return false; }
  virtual uint nbRegisters() const { return 0; }
  uint nbBlocks() const { return _nbBlocks; }
  uint nbBytesPage() const { return _nbBytesPage; }

private:
  uint _nbBytes, _nbBlocks, _nbBytesPage;

  friend class XmlToData;
  friend class Group;
};

}; // namespace

#endif
