/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DEVICES_DATA_H
#define DEVICES_DATA_H

#include "pic.h"

namespace Pic
{
struct ConstConfigValue {
  const char *name, *cname, *ecnames[2];
  uint value;
};

struct ConstConfigMask {
  const char *name, *icnames[2];
  uint value;
  ConstConfigValue values[26];
};

struct ConstConfigWord {
  const char *name;
  uint rmask, wmask, pmask, cmask, bvalue;
  ConstConfigMask masks[12];
};

struct SfrData {
  const char *name;
  uint address;
};

struct ConstMirrored
{
  RangeData ranges[9];
};

struct ConstData {
  Device::ConstData gdata;
  uint id;
  MemoryTechnology memoryTechnology;
  VoltageData voltages[Nb_ProgVoltageTypes];
  MemoryRangeData ranges[Nb_MemoryRangeTypes];
  ConstConfigWord configs[15];
  CalibrationData calibration;
  uint nbBanks;
  SfrData sfrs[401];
  ConstMirrored mirrored[18];
  RangeData unused[60];
};
extern const ConstData *CDATA_LIST[];

}; // namespace

#endif
