/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PIC_CONFIG_EDITOR_H
#define PIC_CONFIG_EDITOR_H

#include <qvaluevector.h>
#include <ktabwidget.h>
#include <ktabbar.h>

#include "pic_memory_editor.h"

//----------------------------------------------------------------------------
class TabWidget : public KTabWidget
{
Q_OBJECT
public:
  TabWidget(QWidget *parent);

protected:
  virtual void wheelEvent(QWheelEvent *e);
};

class TabBar : public KTabBar
{
Q_OBJECT
public:
  TabBar(QWidget *parent, const char *name) : KTabBar(parent, name) {}

protected:
  virtual void wheelEvent(QWheelEvent *e);
};

//----------------------------------------------------------------------------
namespace Pic
{
class HexView;

class MemoryConfigEditorWidget : public Device::MemoryEditorGroup, public MemoryCaster
{
Q_OBJECT
public:
  MemoryConfigEditorWidget(Memory &memory, QWidget *parent);
};

//----------------------------------------------------------------------------
class MemoryConfigEditor : public MemoryTypeEditor
{
Q_OBJECT
public:
  MemoryConfigEditor(const HexView &hexview, Memory &memory, QWidget *parent);
  virtual void init();
};

}; // namespace

#endif
