/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *   Copyright (C) 2003-2004 Alain Gibaud <alain.gibaud@free.fr>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef GLOBAL_CONFIG_H
#define GLOBAL_CONFIG_H

class KConfig;

#include "progs/base/generic_prog.h"
#include "common/gui/purl.h"
#include "devices/base/hex_buffer.h"
#include "device_gui.h"
#include "tools/tool.h"

//-----------------------------------------------------------------------------
class GlobalConfig
{
public:
  static KConfig &config();

  static PURL openedProject();
  static void writeOpenedProject(const PURL &p);
  static PURL::List openedFiles();
  static void writeOpenedFiles(const PURL::List &files);

  static void writeProgrammerGroup(const Programmer::Group &group);
  static const Programmer::Group &programmerGroup();
  static void writeDebugLevel(Log::DebugLevel level);
  static Log::DebugLevel debugLevel();
  static void writeProgramAfterBuild(bool program);
  static bool programAfterBuild();
  static void writeUserIdSetToChecksum(bool set);
  static bool isUserIdSetToChecksum();
};

//-----------------------------------------------------------------------------
namespace DeviceChooser
{
class Config
{
public:
  static KConfig &config();
  static Dialog::ListType listType();
  static void writeListType(Dialog::ListType type);
  static bool filterEnabled();
  static void writeFilterEnabled(bool enabled);
  static uint programmerIndex();
  static void writeProgrammerIndex(uint i);
  static uint compilerIndex();
  static void writeCompilerIndex(uint i);
};
}; // namespace

//-----------------------------------------------------------------------------
class GuiConfig
{
public:
  static KConfig &config();
};

#endif
