/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include <kapp.h>
#include <klocale.h>
#include <kcmdlineargs.h>

#include "toplevel.h"
#include "common/about.h"

const KCmdLineOptions OPTIONS[] = {
  { "+[file]", I18N_NOOP("Optional filenames to be opened upon startup."), 0 },
  { 0, 0, 0}
};

int main(int argc, char **argv)
{
  AboutData ad;
  KCmdLineArgs::init(argc, argv, &ad);
  KCmdLineArgs::addCmdLineOptions(OPTIONS);
  KApplication::addCmdLineOptions();

  KApplication a;
  if ( a.isRestored() ) RESTORE(MainWindow)
  else {
    MainWindow *wid = new MainWindow;
    wid->show();
  }
  return a.exec();
}
