/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PORT_H
#define PORT_H

#include <qstringlist.h>

#include "common/qflags.h"

namespace Port
{
//-----------------------------------------------------------------------------
  extern void msleep(uint ms); // in milliseconds
  extern void usleep(uint us); // in microseconds

//-----------------------------------------------------------------------------
  enum Type { SerialType = 0, ParallelType, USBType, Nb_Types };
  struct Data {
    const char *label, *key;
    bool withDevice;
  };
  extern const Data DATA[Nb_Types];
  enum IOType { NoIO = 0, Input = 1, Output = 2 };
  Q_DECLARE_FLAGS(IOTypes, IOType)
  Q_DECLARE_OPERATORS_FOR_FLAGS(IOTypes)
  extern QStringList probedDeviceList(Type type);
  extern bool isAvailable(Type type);
  struct PinData {
    uint pin;
    const char *label;
  };
  enum LogicType { PositiveLogic, NegativeLogic };

  class Base;

}; // namespace

#endif
