/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PROG_GROUP_UI_H
#define PROG_GROUP_UI_H

#include <kdialogbase.h>

#include "common/group.h"
class Container;
class PopupButton;

namespace Programmer
{
class ConfigWidget;
class Base;
class Group;

//----------------------------------------------------------------------------
class AdvancedDialog : public KDialogBase
{
Q_OBJECT
public:
  AdvancedDialog(Base &base, QWidget *parent, const char *name);
  virtual void updateDisplay();

protected:
  Base      &_base;
  Container *_container, *_firmwareContainer;
  PopupButton *createButton(const QString &text, const char *slot, QWidget *parent);
  bool connectProgrammer();

protected:
  void ensureConnected();

protected slots:
  void updateFirmware();
  void uploadFirmware();

private:
  QLabel *_firmwareLabel;
};

//----------------------------------------------------------------------------
class GroupUI : public ::GroupUI
{
public:
  GroupUI(::Group &group) : ::GroupUI(group) {}
  virtual Programmer::ConfigWidget *createConfigWidget(QWidget *parent) const = 0;
  virtual bool hasAdvancedDialog() const = 0;
  virtual AdvancedDialog *createAdvancedDialog(Base &base, QWidget *parent) const = 0;
};

}; // namespace

#endif
