/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PROGRAMMER_CONFIG_H
#define PROGRAMMER_CONFIG_H

#include "port/port.h"
#include "generic_prog.h"

class KConfig;

namespace Programmer
{
class Group;

class Config
{
public:
  //----------------------------------------------------------------------------
  static KConfig &config(const Group &group);
  static Port::Type readPortType(const Group &group);
  static void writePortType(const Group &group, Port::Type portType);
  static QString readPortDevice(const Group &group, Port::Type portType);
  static void writePortDevice(const Group &group, Port::Type portType, const QString &device);
  static QString readFirmwareDirectory(const Group &group);
  static void writeFirmwareDirectory(const Group &group, const QString &path);

  //----------------------------------------------------------------------------
  static KConfig &config();
  static bool onlyProgramNonMask();
  static void writeOnlyProgramNonMask(bool only);
  static bool onlyVerifyProgrammed();
  static void writeOnlyVerifyProgrammed(bool only);
  static bool powerDownAfterProgramming();
  static void writePowerDownAfterProgramming(bool powerDown);
  static bool isTargetSelfPowered();
  static void writeTargetSelfPowered(bool selfPowered);
  static void writeBlankCheckAfterErase(bool check);
  static bool blankCheckAfterErase();
  static void writePreserveEeprom(bool preserve);
  static bool preserveEeprom();
};

}; // namespace

#endif
