/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "prog_group.h"

#include "generic_prog.h"

Programmer::Base *Programmer::Group::createProgrammer(const Device::Data *data, Port::Type type, const QString &portDevice) const
{
  Base *base = createBase(data);
  Hardware *hardware = createHardware(*base, type, portDevice);
  DeviceSpecific *ds = (data ? createDeviceSpecific(*base) : 0);
  base->init(hardware, ds);
  return base;
}

bool Programmer::Group::checkConnection(Port::Type type, const QString &portDevice) const
{
  Base *base = createProgrammer(0, type, portDevice);
  bool ok = base->simpleConnectHardware();
  delete base;
  return ok;
}
