/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "prog_list.h"

#include "progs/direct/direct_prog.h"
#include "progs/direct/gui/direct_config_widget.h"
#include "progs/icd2/icd2_prog.h"
#include "progs/icd2/icd2_debug.h"
#include "progs/icd2/gui/icd2_group_ui.h"
#include "progs/pickit2/pickit2_prog.h"
#include "progs/pickit2/gui/pickit2_group_ui.h"
#include "progs/pickit1/pickit1_prog.h"
#include "progs/pickit1/gui/pickit1_group_ui.h"

Programmer::Lister::Lister()
{
  Group *g = new Direct::DGroup;
  new Direct::GroupUI(*g);
  addGroup(g);
  g = new Icd2::ProgrammerGroup;
  new Icd2::GroupUI(*g);
  addGroup(g);
  g = new Icd2::DebuggerGroup;
  new Icd2::GroupUI(*g);
  addGroup(g);
  g = new Pickit2::Group;
  new Pickit2::GroupUI(*g);
  addGroup(g);
  g = new Pickit1::Group;
  new Pickit1::GroupUI(*g);
  addGroup(g);
}
