/***************************************************************************\
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DIRECT_MEM24_H
#define DIRECT_MEM24_H

#include "devices/mem24/mem24_memory.h"
#include "direct_pic.h"

namespace Direct
{

class Mem24DeviceSpecific : public ::Programmer::DeviceSpecific, public PulseEngine
{
public:
  Mem24DeviceSpecific(::Programmer::Base &base);
  const Mem24::Data &device() const { return static_cast<const Mem24::Data &>(*::Programmer::DeviceSpecific::_base.device()); }
  virtual bool init() { return true; }
  virtual void setPowerOff();
  void setPowerOn();
  virtual void setTargetVddOn(bool on);

private:
  virtual Device::Array doRead();
  virtual bool doWrite(const Device::Array &data);
  void start();
  void stop();
  uint read_byte(bool withAck);
  bool write_byte(uint v);
};

}; // namespace

#endif
