/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "direct_prog.h"

#include "devices/base/device_group.h"
#include "devices/base/device_list.h"
#include "progs/base/prog_config.h"
#include "direct_prog_config.h"
#include "direct_mem24.h"

void Direct::DGroup::initSupported()
{
  Group::initSupported();
//  const Device::Group *group = Device::lister().group("mem24");
//  QStringList devices = group->supportedDevices();
//  for (uint i=0; i<devices.count(); i++)
//    addDevice(group->deviceData(devices[i]));
}

::Programmer::Base *Direct::DGroup::createBase(const Device::Data *data) const
{
  if ( data->group().name()=="pic" ) return new PicBase(*this, static_cast<const Pic::Data *>(data));
  return new Mem24Base(*this, static_cast<const Mem24::Data *>(data));
}

::Programmer::Hardware *Direct::DGroup::createHardware(::Programmer::Base &base, Port::Type type, const QString &portDevice) const
{
  QString current = Config::currentHardware(type);
  Hardware::HData data = Config::hardware(current).data;
  if ( type==Port::SerialType ) return new SerialHardware(base, portDevice, data);
  return new ParallelHardware(base, portDevice, data);
}

::Programmer::DeviceSpecific *Direct::DGroup::createDeviceSpecific(::Programmer::Base &base) const
{
  if ( base.device()->group().name()=="pic" ) return Group::createDeviceSpecific(base);
  return new Mem24DeviceSpecific(base);
}
