/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *   Copyright (C) 2003-2005 Alain Gibaud <alain.gibaud@free.fr>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DIRECT_PROG_CONFIG_H
#define DIRECT_PROG_CONFIG_H

#include <qstringlist.h>
class KConfig;

#include "port/port.h"
#include "direct_hardware.h"

namespace Direct
{
  struct HardwareData {
    Port::Type portType;
    Hardware::HData data;
  };
  struct StandardHardwareData {
    const char *name, *label, *comment;
    HardwareData hdata;
  };

class Config
{
public:
  static QStringList hardwareNames(Port::Type type);
  static bool isStandardHardware(const QString &name) { return standardHardwareData(name)!=0; }
  static const StandardHardwareData *standardHardwareData(const QString &name);
  static HardwareData hardware(const QString& name);
  static void writeCustomHardware(const QString &name, const HardwareData &data);
  static QString currentHardware(Port::Type type);
  static void writeCurrentHardware(Port::Type type, const QString &name);
  static void deleteCustomHardware(const QString &name);

private:
  static KConfig &config();
  static const StandardHardwareData STANDARD_HARDWARE_DATA[];
};

}; //namespace

#endif
