/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef ICD2_GROUP_UI_H
#define ICD2_GROUP_UI_H

#include "progs/base/gui/prog_group_ui.h"
#include "progs/icd2/icd2_prog.h"

namespace Icd2
{
class ProgrammerBase;
class Group;

//----------------------------------------------------------------------------
class AdvancedDialog : public ::Programmer::AdvancedDialog
{
Q_OBJECT
public:
  AdvancedDialog(ProgrammerBase &base, QWidget *parent);

private slots:
  void updateVoltages();
  void updateSelfTest();

private:
  QLabel *_firmwareIdLabel;
  QLabel *_voltages[Nb_VoltageTypes], *_tests[TestData::Nb_VoltageTypes];
  ProgrammerBase &base() { return static_cast<ProgrammerBase &>(_base); }
  virtual void updateDisplay();
};

//----------------------------------------------------------------------------
class GroupUI : public ::Programmer::GroupUI
{
public:
  GroupUI(::Group &group) : ::Programmer::GroupUI(group) {}
  virtual ::Programmer::ConfigWidget *createConfigWidget(QWidget *parent) const;
  virtual bool hasAdvancedDialog() const { return true; }
  virtual ::Programmer::AdvancedDialog *createAdvancedDialog(::Programmer::Base &base, QWidget *parent) const;
};

}; // namespace

#endif
