/***************************************************************************
 * Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PICKIT1_PROG_H
#define PICKIT1_PROG_H

#include "progs/pickit2/pickit_prog.h"

namespace Pickit1
{
//----------------------------------------------------------------------------
class Base : public Pickit::Base
{
Q_OBJECT
public:
  Base(const Programmer::Group &group, const Pic::Data *data) : Pickit::Base(group, data) {}

private:
  virtual VersionData minVersion() const { return VersionData(2, 0, 0); }
  virtual VersionData maxVersion() const { return VersionData(2, 0, 0); }
};

//----------------------------------------------------------------------------
class Group : public Pickit::Group
{
public:
  virtual QString name() const { return "pickit1"; }
  virtual QString label() const { return i18n("PICkit1"); }
  virtual Programmer::Properties properties() const { return ::Programmer::HaveFirmware; }

protected:
  virtual void initSupported();
  virtual Programmer::Base *createBase(const Device::Data *data) const { return new Base(*this, static_cast<const Pic::Data *>(data)); }
  virtual Programmer::Hardware *createHardware(Programmer::Base &base, Port::Type type, const QString &portDevice) const;
  virtual Programmer::DeviceSpecific *createDeviceSpecific(Programmer::Base &base) const;
};

}; // namespace

#endif
