/***************************************************************************
 * Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PICKIT_PROG_H
#define PICKIT_PROG_H

#include <klocale.h>

#include "devices/pic/pic_prog.h"
#include "progs/base/prog_group.h"
#include "progs/icd2/microchip.h"

namespace Pickit
{
class Hardware;

//----------------------------------------------------------------------------
class Base : public Programmer::PicBase
{
Q_OBJECT
public:
  Base(const Programmer::Group &group, const Pic::Data *data);
  virtual bool readFirmware();

protected:
  Hardware &hardware();
  virtual bool internalSetResetMode(Pic::ResetMode) { return false; }
  virtual bool internalSetupHardware();
  virtual VersionData minVersion() const = 0;
  virtual VersionData maxVersion() const = 0;
};

//----------------------------------------------------------------------------
class Group : public Programmer::Group
{
public:
  virtual Programmer::Properties properties() const = 0 ;
  virtual bool isPortSupported(Port::Type type) const { return ( type==Port::USBType ); }
};

}; // namespace

#endif
