/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef REGISTER_EDITOR_H
#define REGISTER_EDITOR_H

#include "device_editor.h"
#include "devices/base/gui/register_view.h"

namespace Register
{
  extern const char * const LISTVIEW_LABEL;
  extern void showView();

class View : public DeviceEditor
{
Q_OBJECT
public:
  View(const QString &title, const QString &tag, QWidget *parent = 0);
  virtual void setDevice(const QString &device, bool force = false);
  bool isDebugging() const { return _debugging; }
  void setActive(bool active) { if (view()) view()->setActive(active); }
  void setWatched(uint index, bool watched) { if (view()) view()->setWatched(index, watched); }
  void setRegisterValue(uint index, uint value) { if (view()) view()->setRegisterValue(index, value); }

public slots:
  void readAll();
  void stopWatchAll();

signals:
  void readSignal(uint i);
  void writeSignal(uint i, uint value);
  void setWatchedSignal(uint i, bool watched);

private:
  bool _debugging;

  virtual QWidget *createView(const Device::Data *data, QWidget *parent);
  Device::RegisterView *view() { return static_cast<Device::RegisterView *>(_view); }
};

}; // namespace

#endif
