/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef GPUTILS_H
#define GPUTILS_H

#include <klocale.h>

#include "tool.h"

namespace GPUtils
{
  extern QString toDeviceName(const QString &device);

class Base : public Tool::Base
{
public:
  Base(const char *executable) : Tool::Base(executable) {}

private:
  virtual bool checkExecutable(const QString &exec, bool withWine) const;
};

class Group : public Tool::Group
{
public:
  virtual QString name() const { return "gputils"; }
  virtual QString label() const { return i18n("GPUtils"); }
  virtual QString downloadText() const;
  virtual PDirectory linkerScriptsDirectory() const;
  virtual PURL linkerScriptUrl(Compile::LinkType type, const QString &device) const;
  virtual PDirectory headerFilesDirectory() const;
  virtual bool needs(Tool::ActionType type, Tool::Category category) const;
  virtual PURL::FileType sourceFileType(PURL::SourceType type) const;
  virtual QString generateDeviceConfig(PURL::SourceType type, const Device::Memory &memory, bool &ok) const;

private:
  virtual Tool::Base *baseFactory(Tool::Category c) const;
  virtual void initSupported();
  virtual Compile::Process *processFactory(Tool::Category category, const ::Project *project) const;
  virtual ToolConfigWidget *configWidgetFactory(Tool::Category category, ::Project *project) const;
  virtual Compile::Config *configFactory(::Project *project) const;
};

}; // namespace

#endif
