/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef GPUTILS_COMPILE_H
#define GPUTILS_COMPILE_H

#include "compile.h"

namespace GPUtils
{
//-----------------------------------------------------------------------------
class AssembleFile : public Compile::Process
{
Q_OBJECT
private:
  virtual void logStderrLine(const QString &line);

  struct MessageData {
    const char *name, *label;
    Log::Type type;
  };
  static const MessageData MESSAGES[];
};

//-----------------------------------------------------------------------------
class AssembleStandaloneFile : public AssembleFile
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class AssembleProjectFile : public AssembleFile
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class LinkProject : public Compile::Process
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;
  static Log::Type logType(const QString &line, bool &isDebug);

private:
  virtual void logStderrLine(const QString &line);
  virtual QStringList arguments() const;
};

}; // namespace

#endif
