/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef PIC30_COMPILE_H
#define PIC30_COMPILE_H

#include "compile.h"
#include "tools/pic30.h"

namespace PIC30
{
//-----------------------------------------------------------------------------
class CompileFile : public Compile::Process
{
Q_OBJECT
private:
  virtual void logStderrLine(const QString &line);
};

class CompileStandaloneFile : public CompileFile
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

class CompileProjectFile : public CompileFile
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class AssembleFile : public Compile::Process
{
Q_OBJECT
private:
  virtual void logStderrLine(const QString &line);
};

class AssembleStandaloneFile : public AssembleFile
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

class AssembleProjectFile : public AssembleFile
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;

};

//-----------------------------------------------------------------------------
class Link : public Compile::Process
{
Q_OBJECT
private:
  virtual void logStderrLine(const QString &line);
};

class LinkStandalone : public Link
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

class LinkProject : public Link
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class BinToHexBase : public Compile::Process
{
Q_OBJECT
private:
  virtual void logStderrLine(const QString &line);
};

class BinToHexProject : public BinToHexBase
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

class BinToHexStandalone : public BinToHexBase
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

}; // namespace

#endif
