/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef SDCC_COMPILE_H
#define SDCC_COMPILE_H

#include "compile.h"

namespace PICC
{
//-----------------------------------------------------------------------------
class Process : public Compile::Process
{
Q_OBJECT
protected:
  virtual QStringList arguments() const;
  virtual void logStderrLine(const QString &line);
};

//-----------------------------------------------------------------------------
class CompileStandaloneFile : public Process
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class CompileProjectFile : public Process
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class AssembleStandaloneFile : public Process
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class AssembleProjectFile : public Process
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

//-----------------------------------------------------------------------------
class LinkProject : public Process
{
Q_OBJECT
public:
  virtual Compile::FileData::List files() const;

private:
  virtual QStringList arguments() const;
};

}; // namespace

#endif
