/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef WATCH_VIEW_H
#define WATCH_VIEW_H

class KPopupMenu;
#include "common/gui/misc_gui.h"
namespace Device { class Data; };

namespace Watch
{
class View : public ListView
{
Q_OBJECT
public:
  View(QWidget *parent);
  const Device::Data *data() { return _data; }
  void init();
  void setWatched(uint index, bool watched);
  void setRegisterValue(uint index, uint value);

private slots:
  void itemClicked(int button, QListViewItem *item, const QPoint &p, int col);
  void contextMenu(QListViewItem *item, const QPoint &p, int col);
  void stopWatchAll();

private:
  const Device::Data *_data;
  KListViewItem *_rootItem;
  KPopupMenu    *_popup;
};

}; // namespace

#endif
